#include "poch.h"
#include "dir.h"
extern int pintacarta;
extern int pintapalo;
extern char uno[11], dos[11], tres[11], cuatro[11], cinco[11], total[40];
extern int tot;

/********************
Inigraf
inicia los graficos
**********************/
int Inigraf(void)
{
   int gdriver = DETECT, gmode, errorcode;
	int diskete;
	diskete=getdisk();
	if (diskete==0) Final(5);
	initgraph(&gdriver, &gmode, "");  errorcode = graphresult();
	if (errorcode != grOk)  /* an error occurred */
		{printf("Graphics error: %s\n", grapherrormsg(errorcode));Final(2);}             /* return with error code */
	Jefe();
	Pintapantalla();
	Pintanumeritos();
	Pintaopciones();
	Pongopaleta();

}

/***************************
Lastuyas
Pinta las tuyas (cuantas)
****************************/
void Lastuyas(int cuantas)
{
int x=80,y=370;
int i,a,bucle;
char *bufer;
char ruta[20];
int auxiliar;
setcolor(7);
for (bucle=0;bucle<cuantas;bucle++)
{
auxiliar=uno[bucle];
if (pintapalo==1) auxiliar-=10;
if (pintapalo==2) auxiliar-=20;
if (pintapalo==3) auxiliar-=30;
if(auxiliar<0) auxiliar+=40; 
if(uno[0]==43) auxiliar=43; //el dorso es igual para todas.
bufer=malloc(2054);

sprintf(ruta,"carta%02d.vic",auxiliar);
i=open(ruta,O_RDONLY);
if(i==-1) {printf("Abriendo %s\n",ruta);getch();Final(3);}
a=lseek(i,0,0);
a=_read(i,bufer,2054);
if(a!=2054) {printf("Leyendo %s\n",ruta);getch();Final(3);}
close(i);
putimage(x+70*bucle,y,bufer,0);
rectangle(x-3+70*bucle,y-3,x+50+(70*bucle),y+67);
free(bufer);
}		     //53*69

for(bucle=cuantas;bucle<8;bucle++)
{
int poly[8];
setcolor(0);
poly[0]=x-3+70*bucle-3;poly[1]=y-3-3;
poly[2]=x+50+70*bucle+3;poly[3]=y-3-3;
poly[4]=x+50+70*bucle+3;poly[5]=y+67+3;
poly[6]=x-3+70*bucle-3;poly[7]=y+67+3;
setfillstyle(1,0);
fillpoly(4,poly);
setcolor(7);
}
}

/***********************
Ponec
Pone cart a jugador
***********************/
void Ponec(int jugador,int cart)
{
int i,a,bucle; char *bufer;
char ruta[20]; int x,y;
int poly[8];
int auxiliar;

if (jugador==1) {x=275;y=215;}
else if (jugador==2) {x=350;y=135;}
else if (jugador==3) {x=235;y=65;}
else if (jugador==4) {x=110;y=120;}
else if (jugador==5) {x=155;y=225;}
else printf("ERROR aus Ponec");
auxiliar=cart;
if (pintapalo==1) auxiliar-=10;
if (pintapalo==2) auxiliar-=20;
if (pintapalo==3) auxiliar-=30;
if(auxiliar<0) auxiliar+=40; 
//cart=44;
//if (cart==44) auxiliar=44;

setcolor(7);
bufer=malloc(2054);
sprintf(ruta,"carta%02d.vic",auxiliar);
i=open(ruta,O_RDONLY);
if(i==-1) {printf("ERror de archi");Final(3);}
a=lseek(i,0,0);
a=_read(i,bufer,2054);
if(a!=2054) {printf("longi erro");Final(3);}
close(i);
putimage(x,y,bufer,0);
rectangle(x-3,y-3,x+50,y+67);  //47*64
free(bufer);
//Ahora voy a rellenar un hueco negro muy muy feo
poly[0]=x+51;poly[1]=y;
poly[2]=x+64;poly[3]=y;
poly[4]=x+64;poly[5]=y+68;
poly[6]=x+51;poly[7]=y+68;
setcolor(2);
setfillstyle(1,2);
fillpoly(4,poly);			  //53*69
}

/************************
Pongopaleta
Pone la paleta de windows
*************************/
void Pongopaleta()
{
int a,asa;unsigned char ro,ve,az;char *aux= "  ";
struct palettetype pal;
getpalette(&pal);
asa=open("paleta.pal",O_RDONLY);
if(asa==-1) {printf("Hubo error en paleta.pal");Final(4);}
lseek (asa,54,0); //devuelvo el puntero a su sitio inicial
for (a=0;a<pal.size;a++)
{
read(asa,aux,1);az=aux[0];
read(asa,aux,1);ve=aux[0];
read(asa,aux,1);ro=aux[0];
setrgbpalette(pal.colors[a],ro/4,ve/4,az/4);
read(asa,aux,1);
}
lseek (asa,0,0);close (asa);
}

void Limpiatapete(void)
{
int i,jugador,x,y;
int poly[8];
setcolor(2);
setfillstyle(1,2);
for (jugador=1;jugador<6;jugador++)
{
if (jugador==1) {x=275;y=215;}
else if (jugador==2) {x=350;y=135;}
else if (jugador==3) {x=235;y=65;}
else if (jugador==4) {x=110;y=120;}
else if (jugador==5) {x=155;y=225;}
x-=6;
y-=6;

poly[0]=x;
poly[1]=y;
poly[2]=x+47+26;
poly[3]=y;
poly[4]=x+47+26;
poly[5]=y+64+9;
poly[6]=x;
poly[7]=y+64+9;
fillpoly(4,poly);
}
Mensaje(-1);
setcolor(7);
}

/*************************
Pesetas
Presenta el numero de pesetas 
**************************/
void Pesetas(int jugador,int cuantas)
{
int x,y;
//cuantas=8;
if (jugador==1) {x=275;y=315;}
else if (jugador==2) {x=440;y=135;}
else if (jugador==3) {x=235;y=35;}
else if (jugador==4) {x=80;y=80;}
else if (jugador==5) {x=85;y=225;}
setcolor(0);
if (cuantas==0) line(x-4,y,x+4,y);
if (cuantas)
	{circle(x,y,5);cuantas--;}
if (cuantas)
	{circle(x,y+16,5);cuantas--;}
if (cuantas)
	{circle(x+16,y+16,5);cuantas--;}
if (cuantas)
	{circle(x+16,y,5);cuantas--;}
if (cuantas)
	{circle(x-16,y,5);cuantas--;}
if (cuantas)
	{circle(x-16,y-16,5);cuantas--;}
if (cuantas)
	{circle(x,y-16,5);cuantas--;}
if (cuantas)
	{circle(x+16,y-16,5);cuantas--;} //28E
}
/***********************************
Limpiapesetas
************************************/
void Limpiapesetas()
{
int jugador,x,y;
int poly[8];
	setcolor(2);
	setfillstyle(1,2);
poly[0]=6;poly[1]=6;
poly[2]=499;poly[3]=6;
poly[4]=499;poly[5]=349;
poly[6]=6;poly[7]=349;
fillpoly(4,poly);
}

/**********************************
Es para poner lo que puedes y no hacer
Cero significa encender
Uno significa apagar
*********************************/
void Pintatuturno(int quitar,int prohibido)
{
int i;
setcolor(7);
if (quitar==0) setfillstyle(1,15);
else setfillstyle(1,0);
floodfill(50,470,7);
settextstyle(2,0,6);
setcolor(11);
i=tot+1;
if(quitar==0)
	{
	if(i) {outtextxy(20,352,"0");i--;}
	if(i) {outtextxy(20,377,"1");i--;}
	if(i) {outtextxy(20,402,"2");i--;}
	if(i) {outtextxy(20,427,"3");i--;}
	if(i) {outtextxy(20,452,"4");i--;}
	if(i) {outtextxy(50,352,"5");i--;}
	if(i) {outtextxy(50,377,"6");i--;}
	if(i) {outtextxy(50,402,"7");i--;}
	if(i) {outtextxy(50,427,"8");i--;}
	}
setcolor(7);
if(quitar==1)
	{
	outtextxy(20,352,"0"); 	outtextxy(50,352,"5");	
	outtextxy(20,377,"1");  outtextxy(50,377,"6");
	outtextxy(20,402,"2");  outtextxy(50,402,"7");	
	outtextxy(20,427,"3");  outtextxy(50,427,"8");
	outtextxy(20,452,"4");
	}
if(prohibido==0)  outtextxy(20,352,"0");
if(prohibido==1)  outtextxy(20,377,"1");
if(prohibido==2)  outtextxy(20,402,"2"); 
if(prohibido==3)  outtextxy(20,427,"3");
if(prohibido==4)  outtextxy(20,452,"4");
if(prohibido==5)  outtextxy(50,352,"5");
if(prohibido==6)  outtextxy(50,377,"6");
}

/******************
Pintapinta
Pinta la carta pinta
*********************/
void Pintapinta(int pintar)
{
int i,a,bucle; char *bufer;
char ruta[20]; int x,y;
int poly[8];
x=420;
y=270;
if (pintar!=-1)
{	setcolor(7);
	bufer=malloc(2054);
	sprintf(ruta,"carta%02d.vic",pintacarta);
	i=open(ruta,O_RDONLY);
	if(i==-1) {printf("ERror de archi");Final(3);}
	a=lseek(i,0,0);
	a=_read(i,bufer,2054);
	if(a!=2054) {printf("longi erro");Final(3);}
	close(i);
	putimage(x,y,bufer,0);
	rectangle(x-3,y-3,x+50,y+67);  //47*64
	free(bufer);
//Ahora voy a rellenar un hueco negro muy muy feo
	poly[0]=x+51;poly[1]=y;
	poly[2]=x+64;poly[3]=y;
	poly[4]=x+64;poly[5]=y+68;
	poly[6]=x+51;poly[7]=y+68;
	setcolor(2);
	setfillstyle(1,2);
	fillpoly(4,poly);			  //53*69
}
else //retirar la carta que pintaba
{	
	poly[0]=x-5;poly[1]=y-5;
	poly[2]=x+64;poly[3]=y-5;
	poly[4]=x+64;poly[5]=y+68;
	poly[6]=x-5;poly[7]=y+68;
	setcolor(2);
	setfillstyle(1,2);
	fillpoly(4,poly);			  //53*69
}	


}

/*************************
Jefe
pone la pantalla en negro
*************************/
void Jefe(void)
{
int a;
unsigned char ro,ve,az;char *aux= "  ";
struct palettetype pal;
getpalette(&pal);
for (a=0;a<pal.size;a++)
	{
	az=0;ve=0;ro=0;
	setrgbpalette(pal.colors[a],ro/4,ve/4,az/4);
	}
}